<?php

/**
 * anular_anu_liq actions.
 *
 * @package    canon
 * @subpackage anular_anu_liq
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class anular_anu_liqActions extends sfQuery {

    public $conn;

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //Parametros de entrada
        $id_titulo = $request['id_titulo'];

        /*
         * Manejo de errores
         */
        try {


            //Anualidades que deben ser truncadas debido a la terminacion de contrato inesperada pero que estan liquidadas
            $sql = <<<EOD
   select count(*) as count from(
   
                       select table1.*, table2.nombre from(select tab2.*, tab1.id_etapa from rmn_titulo tab0 
join ca_titulo_etapa tab1 on tab0.id_titulo=tab1.id_titulo 
JOIN ca_anual_etapa tab2 ON tab1.id_titulo_etapa=tab2.id_titulo_etapa
where tab0.id_titulo=$id_titulo
and tab1.actual=1

minus

    select tab2.*, tab1.id_etapa from rmn_titulo tab0 
join ca_titulo_etapa tab1 on tab0.id_titulo=tab1.id_titulo 
JOIN ca_anual_etapa tab2 ON tab1.id_titulo_etapa=tab2.id_titulo_etapa
where tab0.id_titulo=$id_titulo
AND tab1.actual=1
and tab0.fecha_ter >  tab2.fecha_inicio)table1 join
ca_etapa table2 ON table1.id_etapa=table2.id_etapa
where liquidado =1 order by fecha_inicio 


)tabla
            
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

             //validar si hay registros
            if ($total_record_count > 0) {

                /*
                 * Obtiene los accesos para un perfil
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
                               select table1.*, table2.nombre from(select tab2.*, tab1.id_etapa from rmn_titulo tab0 
join ca_titulo_etapa tab1 on tab0.id_titulo=tab1.id_titulo 
JOIN ca_anual_etapa tab2 ON tab1.id_titulo_etapa=tab2.id_titulo_etapa
where tab0.id_titulo=$id_titulo
and tab1.actual=1

minus

    select tab2.*, tab1.id_etapa from rmn_titulo tab0 
join ca_titulo_etapa tab1 on tab0.id_titulo=tab1.id_titulo 
JOIN ca_anual_etapa tab2 ON tab1.id_titulo_etapa=tab2.id_titulo_etapa
where tab0.id_titulo=$id_titulo
AND tab1.actual=1
and tab0.fecha_ter >  tab2.fecha_inicio)table1 join
ca_etapa table2 ON table1.id_etapa=table2.id_etapa
where liquidado =1 order by fecha_inicio 

            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

            // Solo registra log la primera vez de consulta
            if ($rowStart == 0) {
                //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                $id_ope_bd = 1;
                //obtener id maestro tabla
                $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_anual_etapa');
                //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
            }


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($records);;
            $this->status = 0;
            $this->list_data = $records;
            $this->logMessage("[ANULAR_ANU_LIQ_LIST] Consulta exitosa.");
            
            } else {

                $mensaje = "[ANULAR_ANU_LIQ_LIST] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {


            $error = "[ANULAR_ANU_LIQ_LIST] ERROR: " . $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

     

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
